Index: cprs/trunk/CPRS-Chart/fGraphs.pas
===================================================================
--- cprs/trunk/CPRS-Chart/fGraphs.pas	(revision 456)
+++ cprs/trunk/CPRS-Chart/fGraphs.pas	(revision 830)
@@ -1512,16 +1662,20 @@
   BigTime, SmallTime: TDateTime;
   ChildControl: TControl;
+  aChart: TChart;
 begin
   if not (Sender is TChart) then exit;
+  aChart := (Sender as TChart);
+  if Not Assigned(FGraphSetting) then Exit;
+  
   if not FGraphSetting.VerticalZoom then
   begin
     padding := 0; //(FYMaxValue - FYMinValue) * ((100 - ZOOM_PERCENT) * 0.01);
-    (Sender as TChart).LeftAxis.Maximum := BIG_NUMBER;    // avoid min>max error
-    (Sender as TChart).LeftAxis.Minimum := -BIG_NUMBER;
-    (Sender as TChart).LeftAxis.Maximum := FYMaxValue + padding;    //padding 0?
-    (Sender as TChart).LeftAxis.Minimum := FYMinValue - padding;    //padding 0?
-  end;
-  SmallTime := (Sender as TChart).BottomAxis.Minimum;
-  BigTime := (Sender as TChart).BottomAxis.Maximum;
+    aChart.LeftAxis.Maximum := BIG_NUMBER;    // avoid min>max error
+    aChart.LeftAxis.Minimum := -BIG_NUMBER;
+    aChart.LeftAxis.Maximum := FYMaxValue + padding;    //padding 0?
+    aChart.LeftAxis.Minimum := FYMinValue - padding;    //padding 0?
+  end;
+  SmallTime := aChart.BottomAxis.Minimum;
+  BigTime := aChart.BottomAxis.Maximum;
   if BigTime < SmallTime then BigTime := SmallTime;   // avoid min>max error
   for i := 0 to scrlTop.ControlCount - 1 do
@@ -1537,8 +1691,8 @@
   end;
   SizeDates(chartDatelineBottom, SmallTime, BigTime);
-  if FMouseDown and (Sender as TChart).Zoomed then
+  if FMouseDown and aChart.Zoomed then
   begin
     datehx := FloatToStr(SmallTime) + '^' + FloatToStr(BigTime);
-    lstZoomHistory.Items.Add(datehx);
+    GtslZoomHistoryFloat.Add(datehx);
     mnuPopGraphZoomBack.Enabled := true;
     FMouseDown := false;
@@ -1553,19 +1707,21 @@
   BigTime, SmallTime: TDateTime;
   ChildControl: TControl;
+  aChart: TChart;
 begin
   if not (Sender is TChart) then exit;
+  aChart:= (Sender as TChart);
   FRetainZoom := false;
   mnuPopGraphZoomBack.Enabled := false;
-  lstZoomHistory.Items.Clear;
+  GtslZoomHistoryFloat.Clear;
   if not FGraphSetting.VerticalZoom then
   begin
     padding := 0; //(FYMaxValue - FYMinValue) * ((100 - ZOOM_PERCENT) * 0.01);
-    (Sender as TChart).LeftAxis.Maximum := BIG_NUMBER;    // avoid min>max error
-    (Sender as TChart).LeftAxis.Minimum := -BIG_NUMBER;
-    (Sender as TChart).LeftAxis.Maximum := FYMaxValue + padding;    //padding 0?
-    (Sender as TChart).LeftAxis.Minimum := FYMinValue - padding;    //padding 0?
-  end;
-  SmallTime := (Sender as TChart).BottomAxis.Minimum;
-  BigTime := (Sender as TChart).BottomAxis.Maximum;
+    aChart.LeftAxis.Maximum := BIG_NUMBER;    // avoid min>max error
+    aChart.LeftAxis.Minimum := -BIG_NUMBER;
+    aChart.LeftAxis.Maximum := FYMaxValue + padding;    //padding 0?
+    aChart.LeftAxis.Minimum := FYMinValue - padding;    //padding 0?
+  end;
+  SmallTime := aChart.BottomAxis.Minimum;
+  BigTime := aChart.BottomAxis.Maximum;
   if BigTime < SmallTime then BigTime := SmallTime;   // avoid min>max error
   for i := 0 to scrlTop.ControlCount - 1 do
@@ -1584,7 +1740,5 @@
   begin
     FMouseDown := false;
-    pnlInfo.Caption := '';
-    pnlInfo.Color := COLOR_INFO;
-    pnlInfo.Visible := false;
+    InfoMessage('', COLOR_INFO, false);
     pnlHeader.Visible := false;
   end;
@@ -1594,4 +1748,5 @@
 var
   datediff, yeardiff: integer;
+  pad: double;
 begin
   with aChart.BottomAxis do
@@ -1617,4 +1772,55 @@
     end;
   end;
+  GraphFooter(aChart, datediff, aSmallTime);
+  pad := (aBigTime - aSmallTime) * 0.07;
+  SeriesForLabels(aChart, 'serNonNumBottom', pad);
+  SeriesForLabels(aChart, 'serNonNumTop', pad);
+  if length(aChart.Hint) > 0 then SeriesForLabels(aChart, 'serComments', pad);
+end;
+
+procedure TfrmGraphs.SeriesForLabels(aChart: TChart; aID: string; pad: double);
+var
+  i: integer;
+  aPointSeries: TPointSeries;
+  max, min: double;
+begin
+  for i := 0 to aChart.SeriesCount - 1 do
+  begin
+    if aChart.Series[i].Identifier = aID then
+    begin
+      aPointSeries := (aChart.Series[i] as TPointSeries);
+      aPointSeries.Clear;
+      if aID = 'serNonNumBottom' then
+      begin
+        min := aChart.LeftAxis.Minimum;
+        if min > aChart.MinYValue(aChart.LeftAxis) then
+           min := aChart.MinYValue(aChart.LeftAxis);
+        if min < 0 then min := 0;
+        aPointSeries.AddXY(aChart.BottomAxis.Minimum, min, '', clTeeColor) ;
+      end
+      else if aID  = 'serNonNumTop' then
+      begin
+        max := aChart.LeftAxis.Maximum;
+        if max < aChart.MaxYValue(aChart.LeftAxis) then
+           max := aChart.MaxYValue(aChart.LeftAxis);
+        aPointSeries.AddXY(aChart.BottomAxis.Minimum, max, '', clTeeColor) ;
+      end
+      else if aID = 'serComments' then
+      begin
+        min := aChart.MinYValue(aChart.LeftAxis);
+        if aChart.SeriesCount = 2 then        // only 1 series (besides comment)
+          if aChart.Series[0].Count = 1 then  // only 1 numeric
+            min := min - 1;                   // force comment label to bottom
+        if min < 0 then min := 0;
+        aPointSeries.AddXY((aChart.BottomAxis.Maximum - pad), min, '', clTeeColor) ;
+      end;
+      aPointSeries.Marks.Visible := true;
+      break;
+    end;
+  end;
+end;
+
+procedure TfrmGraphs.GraphFooter(aChart: TChart; datediff: integer; aDate: TDateTime);
+begin
   if datediff < 1 then
   begin
@@ -1622,5 +1828,5 @@
     begin
       aChart.Foot.Text.Clear;
-      aChart.Foot.Text.Insert(0, FormatDateTime('mmm d, yyyy', aSmallTime));
+      aChart.Foot.Text.Insert(0, FormatDateTime('mmm d, yyyy', aDate));
       aChart.Foot.Font.Color := clBtnText;
       aChart.Foot.Visible := true;
@@ -1634,8 +1840,5 @@
   TListView; aPadPanel: TPanel; section: string);
 var
-  acnt, bcnt, displayheight, displaynum, gcnt, graphtype, i, j, lcnt, ncnt, pcnt, vcnt: integer;
-  aTitle, checkdata, filetype, high, low, specimen, specnum, typeitem, units: string;
-  newchart: TChart;
-  aGraphItem: TGraphItem;
+  displayheight, displaynum, i: integer;
 begin
   FNonNumerics := false;
@@ -1654,94 +1857,5 @@
     chartDatelineBottom.OnMouseMove := nil;
   end;
-  pcnt := 0; gcnt := 0; vcnt := 0; lcnt := 0; ncnt := 0; bcnt := 0; acnt := 0;
-  for j := 0 to aListView.Items.Count - 1 do
-  if aListView.Items[j].Selected then
-  begin
-    aGraphItem := TGraphItem(aListView.Items.Item[j].SubItems.Objects[3]);
-    filetype := UpperCase(Piece(aGraphItem.Values, '^', 1));
-    typeitem := UpperCase(Piece(aGraphItem.Values, '^', 2));
-    graphtype := GraphTypeNum(filetype); //*****strtointdef(Piece(aListBox.Items[j], '^', 2), 1);
-    if (filetype = '63') and (lstData.Items.Count > 0) then
-    begin
-      checkdata := '';
-      for i := 0 to lstData.Items.Count - 1 do
-      begin
-        checkdata := lstData.Items[i];
-        if (Piece(checkdata, '^', 1) = '63') and (Piece(checkdata, '^', 2) = typeitem) then
-          break;
-      end;
-      specnum := Piece(checkdata, '^', 7);
-      specimen := Piece(checkdata, '^', 8);
-      RefUnits(typeitem, specnum, low, high, units);
-      units := LowerCase(units);
-      if units = '' then units := '  ';
-    end
-    else
-    begin
-      specimen := ''; low := ''; high := ''; units := '';
-    end;
-    aTitle := filetype + '^' + typeitem + '^' + aListView.Items[j].Caption + '^' +
-              specimen + '^' + low + '^' + high + '^' + units;
-    newchart := TChart.Create(self);
-    with newchart do
-    begin
-      Parent := aScrollBox;
-      View3D := false;
-      height := 170;
-      Align := alBottom;
-      Align := alTop;
-      AllowPanning := pmNone;
-      Legend.LegendStyle := lsSeries;
-      Legend.ShadowSize := 1;
-      Legend.Color := clCream;
-      Legend.VertMargin := 0;
-      Legend.Alignment := laTop;
-      Legend.Visible := true;
-      Gradient.EndColor := clGradientActiveCaption;
-      //SetPiece(aTitle, '^', 3, 'zzzz: ' + Piece(aTitle, '^', 3)); // test prefix
-      if (graphtype = 1) and (btnChangeSettings.Tag = 1) then
-        LeftAxis.Title.Caption := 'StdDev'
-      else if (graphtype = 1) and (btnChangeSettings.Tag = 2) then
-      begin
-        LeftAxis.Title.Caption := '1/' + units;
-        SetPiece(aTitle, '^', 3, 'Inverse ' + Piece(aTitle, '^', 3));
-      end
-      else
-        LeftAxis.Title.Caption := units;
-      if graphtype <> 1 then
-      begin
-        LeftAxis.Visible := false;
-        MarginLeft := round((50 / (pnlScrollTopBase.Width + 1)) * 100);       // ************* marginleft is a %
-      end;
-      BottomAxis.ExactDateTime := true;
-      BottomAxis.Increment := DateTimeStep[dtOneMinute];
-      HideDates(newchart);
-      BevelOuter := bvNone;
-      OnZoom := ChartOnZoom;
-      OnUndoZoom := ChartOnUndoZoom;
-      OnClickSeries := chartBaseClickSeries;
-      OnClickLegend := chartBaseClickLegend;
-      OnDblClick := mnuPopGraphDetailsClick;
-      OnMouseDown := chartBaseMouseDown;
-      if FGraphSetting.Hints then             //*****
-        OnMouseMove := chartBaseMouseMove
-      else
-        OnMouseMove := nil;
-    end;
-    splGraphs.Tag := 1;    // show ref ranges
-    if graphtype = 4 then graphtype := 2;         // change points to be bars
-    case graphtype of
-      1:  MakeLineSeries(newchart, aTitle, filetype, lcnt, ncnt, false);
-      2:  MakeBarSeries(newchart, aTitle, filetype, bcnt);
-      3:  MakeVisitGanttSeries(newchart, aTitle, filetype, vcnt);
-      4:  MakePointSeries(newchart, aTitle, filetype, pcnt);
-      5:  MakeArrowSeries(newchart, aTitle, filetype, acnt);
-      6:  MakeGanttSeries(newchart, aTitle, filetype, gcnt);
-      7:  MakeAGanttSeries(newchart, aTitle, filetype, gcnt);
-      8:  MakeManyGanttSeries(newchart, aTitle, filetype, gcnt);
-      9:  MakeWeightedArrowSeries(newchart, aTitle, filetype, acnt);
-     10:  MakeWeightedGanttSeries(newchart, aTitle, filetype, gcnt);
-    end;
-  end;
+  MakeSeparateItems(aScrollBox, aListView, section);
   if section = 'top' then
   begin
@@ -1773,10 +1887,4 @@
       Controls[i].height := displayheight;
   end;
-  if (FGraphSetting.HighTime = FGraphSetting.LowTime)
-  or (lcnt = 1) or (pcnt = 1) or (bcnt = 1) or (vcnt = 1) then
-  begin
-    FGraphSetting.HighTime := FGraphSetting.HighTime + 1;
-    FGraphSetting.LowTime := FGraphSetting.LowTime - 1;
-  end;
   AdjustTimeframe;
   if chartDatelineTop.Visible then chartDatelineTop.ZoomPercent(ZOOM_PERCENT);
@@ -1787,15 +1895,190 @@
 end;
 
+function TfrmGraphs.TitleInfo(filetype, typeitem, caption: string): string;
+var
+  i: integer;
+  checkdata, high, low, specimen, specnum, units: string;
+begin
+  if (filetype = '63') and (GtslData.Count > 0) then
+  begin
+    checkdata := '';
+    for i := 0 to GtslData.Count - 1 do
+    begin
+      checkdata := GtslData[i];
+      if (Piece(checkdata, '^', 1) = '63') and (Piece(checkdata, '^', 2) = typeitem) then
+        break;
+    end;
+    specnum := Piece(checkdata, '^', 7);
+    specimen := Piece(checkdata, '^', 8);
+    RefUnits(typeitem, specnum, low, high, units);
+    units := LowerCase(units);
+    if units = '' then units := '  ';
+  end
+  else
+  begin
+    specimen := ''; low := ''; high := ''; units := '';
+  end;
+  Result := filetype + '^' + typeitem + '^' + caption + '^' +
+            specimen + '^' + low + '^' + high + '^' + units + '^';
+end;
+
+procedure TfrmGraphs.MakeSeparateItems(aScrollBox: TScrollBox; aListView: TListView; section: string);
+var
+  bcnt, gcnt, graphtype, lcnt, ncnt, pcnt, vcnt: integer;
+  aTitle, filetype, typeitem: string;
+  newchart: TChart;
+  aGraphItem: TGraphItem;
+  aListItem: TListItem;
+begin
+  pcnt := 0; gcnt := 0; vcnt := 0; lcnt := 0; ncnt := 0; bcnt := 0;
+  aListItem := aListView.Selected;
+  while aListItem <> nil do
+  begin
+    aGraphItem := TGraphItem(aListItem.SubItems.Objects[3]);
+    filetype := UpperCase(Piece(aGraphItem.Values, '^', 1));
+    typeitem := UpperCase(Piece(aGraphItem.Values, '^', 2));
+    graphtype := GraphTypeNum(filetype); //*****strtointdef(Piece(aListBox.Items[j], '^', 2), 1);
+    aTitle := TitleInfo(filetype, typeitem, aListItem.Caption);
+    newchart := TChart.Create(self);
+    newchart.Tag := GtslNonNum.Count;
+    MakeChart(newchart, aScrollBox);
+    with newchart do
+    begin
+      Height := 170;
+      Align := alBottom;
+      Align := alTop;
+      Tag := aListItem.Index;
+      //SetPiece(aTitle, '^', 3, 'zzzz: ' + Piece(aTitle, '^', 3)); // test prefix
+      if (graphtype = 1) and (btnChangeSettings.Tag = 1) then
+        LeftAxis.Title.Caption := 'StdDev'
+      else if (graphtype = 1) and (btnChangeSettings.Tag = 2) then
+      begin
+        LeftAxis.Title.Caption := '1/' + Piece(aTitle, '^', 7);
+        SetPiece(aTitle, '^', 3, 'Inverse ' + Piece(aTitle, '^', 3));
+      end
+      else
+        LeftAxis.Title.Caption := Piece(aTitle, '^', 7);
+      if graphtype <> 1 then
+      begin
+        LeftAxis.Visible := false;
+        MarginLeft := PadLeftEvent(pnlScrollTopBase.Width);
+        //MarginLeft := round((65 / (pnlScrollTopBase.Width + 1)) * 100);       // ************* marginleft is a %
+      end;
+    end;
+    splGraphs.Tag := 1;    // show ref ranges
+    if graphtype = 4 then graphtype := 2;         // change points to be bars
+    case graphtype of
+      1:  MakeLineSeries(newchart, aTitle, filetype, section, lcnt, ncnt, false);
+      2:  MakeBarSeries(newchart, aTitle, filetype, bcnt);
+      3:  MakeVisitGanttSeries(newchart, aTitle, filetype, vcnt);
+      4:  MakePointSeries(newchart, aTitle, filetype, pcnt);
+      8:  MakeGanttSeries(newchart, aTitle, filetype, gcnt);
+    end;
+    MakeOtherSeries(newchart);
+    aListItem := aListView.GetNextItem(aListItem, sdAll, [isSelected]);
+  end;
+  if (FGraphSetting.HighTime = FGraphSetting.LowTime)
+  or (lcnt = 1) or (pcnt = 1) or (bcnt = 1) or (vcnt = 1) then
+  begin
+    FGraphSetting.HighTime := FGraphSetting.HighTime + 1;
+    FGraphSetting.LowTime := FGraphSetting.LowTime - 1;
+  end;
+end;
+
+function TfrmGraphs.PadLeftEvent(aWidth: integer): integer;
+begin
+  if aWidth < 50 then
+    Result := 10
+  else if aWidth < 100 then
+    Result := 36
+  else if aWidth < 200 then
+    Result := 28
+  else if aWidth < 220 then
+    Result := 24
+  else if aWidth < 240 then
+    Result := 23
+  else if aWidth < 270 then
+    Result := 21
+  else if aWidth < 300 then
+    Result := 18
+  else if aWidth < 400 then
+    Result := 14
+  else if aWidth < 500 then
+    Result := 11
+  else if aWidth < 600 then
+    Result := 10
+  else if aWidth < 700 then
+    Result := 9
+  else if aWidth < 800 then
+    Result := 8
+  else if aWidth < 900 then
+    Result := 7
+  else if aWidth < 1000 then
+    Result := 6
+  else
+    Result := 5;
+end;
+
+function TfrmGraphs.PadLeftNonNumeric(aWidth: integer): integer;
+begin
+  if aWidth < 50 then
+    Result := 10
+  else if aWidth < 100 then
+    Result := 36
+  else if aWidth < 200 then
+    Result := 16
+  else if aWidth < 220 then
+    Result := 14
+  else if aWidth < 240 then
+    Result := 12
+  else if aWidth < 270 then
+    Result := 10
+  else if aWidth < 300 then
+    Result := 9
+  else if aWidth < 400 then
+    Result := 8
+  else if aWidth < 500 then
+    Result := 7
+  else if aWidth < 600 then
+    Result := 6
+  else
+    Result := 5;
+end;
+
+procedure TfrmGraphs.MakeTogetherMaybe(aScrollBox: TScrollBox; aListView:
+  TListView; aPadPanel: TPanel; section: string);
+var
+  filetype: string;
+  aGraphItem: TGraphItem;
+  aListItem: TListItem;
+begin
+  FNonNumerics := false;
+  if section = 'top' then pnlItemsTop.Tag := 0 else pnlItemsBottom.Tag := 0;
+  if aListView.SelCount = 1 then                 // one lab test - make separate
+  begin
+    aListItem := aListView.Selected;
+    aGraphItem := TGraphItem(aListItem.SubItems.Objects[3]);
+    filetype := UpperCase(Piece(aGraphItem.Values, '^', 1));
+    if (filetype = '63') or (filetype = '120.5') then
+    begin
+      MakeSeparate(aScrollBox, aListView, aPadPanel, section);
+      exit;
+    end;
+  end;
+  MakeTogether(aScrollBox, aListView, aPadPanel, section);
+end;
+
 procedure TfrmGraphs.MakeTogether(aScrollBox: TScrollBox; aListView:
   TListView; aPadPanel: TPanel; section: string);
 var
-  anylines, nolines, onlylines, singlelabtest: boolean;
-  acnt, bcnt, cnt, gcnt, graphtype, i, j, lcnt, ncnt, pcnt, vcnt: integer;
+  anylines, nolines, onlylines, singlepoint: boolean;
+  bcnt, gcnt, graphtype, lcnt, pcnt, vcnt: integer;
   portion: double;
-  aTitle, checkdata, filetype, high, low, specimen, specnum, typeitem, units: string;
+  filetype, typeitem: string;
   newchart: TChart;
   aGraphItem: TGraphItem;
-begin
-  pcnt := 0; gcnt := 0; lcnt := 0; ncnt := 0; bcnt := 0; acnt := 0;
+  aListItem: TListItem;
+begin
+  pcnt := 0; gcnt := 0; lcnt := 0; bcnt := 0; vcnt := 0;
   onlylines := true;
   anylines := false;
@@ -1803,28 +2086,10 @@
   FNonNumerics := false;
   if section = 'top' then pnlItemsTop.Tag := 0 else pnlItemsBottom.Tag := 0;
-  if FGraphSetting.Hints then       //******
-  begin
-    chartDatelineTop.OnMouseMove := chartBaseMouseMove;
-    chartDatelineBottom.OnMouseMove := chartBaseMouseMove;
-  end
-  else
-  begin
-    chartDatelineTop.OnMouseMove := nil;
-    chartDatelineBottom.OnMouseMove := nil;
-  end;
-  for j := 0 to aListView.Items.Count - 1 do
-  if aListView.Items[j].Selected then
-  begin
-    aGraphItem := TGraphItem(aListView.Items.Item[j].SubItems.Objects[3]);
+  aListItem := aListView.Selected;
+  while aListItem <> nil do
+  begin
+    aGraphItem := TGraphItem(aListItem.SubItems.Objects[3]);
     filetype := UpperCase(Piece(aGraphItem.Values, '^', 1));
     typeitem := UpperCase(Piece(aGraphItem.Values, '^', 2));
-    if aListView.SelCount = 1 then                 // one lab test - make separate
-    begin
-      if filetype = '63' then
-      begin
-        MakeSeparate(aScrollBox, aListView, aPadPanel, section);
-        exit;
-      end;
-    end;
     graphtype := GraphTypeNum(filetype);
     case graphtype of
@@ -1833,9 +2098,5 @@
     3: vcnt := vcnt + 1;
     4: pcnt := pcnt + 1;
-    5: acnt := acnt + 1;
-    6: gcnt := gcnt + 1;
-    7: gcnt := gcnt + 1;
     8: gcnt := gcnt + 1;
-    9: acnt := acnt + 1;
     end;
     if graphtype = 1 then
@@ -1846,4 +2107,5 @@
     else
       onlylines := false;
+    aListItem := aListView.GetNextItem(aListItem, sdAll, [isSelected]);
   end;
   if section = 'top' then
@@ -1851,41 +2113,15 @@
   else
     chkItemsBottom.Checked := false;
-  lstTempCheck.Items.Clear;
-  while aScrollBox.ControlCount > 0 do
-    aScrollBox.Controls[0].Free;
+  GtslTempCheck.Clear;
+  while aScrollBox.ControlCount > 0 do aScrollBox.Controls[0].Free;
   newchart := TChart.Create(self);  // whynot use base?
+  MakeChart(newchart, aScrollBox);
   with newchart do          // if a single line graph do lab stuff (ref range, units) ****************************************
   begin
-    Parent := aScrollBox;
-    View3D := false;
-    Chart3DPercent := 10;
-    AllowPanning := pmNone;
     Align := alClient;
-    Gradient.EndColor := clGradientActiveCaption;
-    Legend.LegendStyle := lsSeries;
-    Legend.ShadowSize := 1;
-    Legend.Color := clCream;
-    Legend.VertMargin := 0;
-    Legend.Alignment := laTop;
-    Legend.Visible := true;
     LeftAxis.Title.Caption := ' ';
-    BottomAxis.ExactDateTime := true;
-    BottomAxis.Increment := DateTimeStep[dtOneMinute];
-    HideDates(newchart);
-    BevelOuter := bvNone;
-    OnZoom := ChartOnZoom;
-    OnUndoZoom := ChartOnUndoZoom;
-    OnClickSeries := chartBaseClickSeries;
-    OnClickLegend := chartBaseClickLegend;
-    OnDblClick := mnuPopGraphDetailsClick;
-    OnMouseDown := chartBaseMouseDown;
-    if FGraphSetting.Hints then               //******
-      OnMouseMove := chartBaseMouseMove
-    else
-      OnMouseMove := nil;
-    Visible := false;
   end;
   aPadPanel.Visible := true;
-  portion := PortionSize(lcnt, pcnt, gcnt, vcnt, bcnt, acnt);
+  portion := PortionSize(lcnt, pcnt, gcnt, vcnt, bcnt);
   if section = 'top' then
     SizeTogether(onlylines, nolines, anylines, scrlTop, newchart,
@@ -1897,178 +2133,20 @@
   else splGraphs.Tag := 0;
 
-  if nolines then
-  begin
-    pcnt := 0; gcnt := 0; vcnt := 0; bcnt := 0; acnt := 0;
-    for j := 0 to aListView.Items.Count - 1 do
-    if aListView.Items[j].Selected then
-    begin
-      aGraphItem := TGraphItem(aListView.Items.Item[j].SubItems.Objects[3]);
-      filetype := Piece(aGraphItem.Values, '^', 1);
-      typeitem := Piece(aGraphItem.Values, '^', 2);
-      aTitle := filetype + '^' + typeitem + '^' + aListView.Items[j].Caption + '^';
-      graphtype := GraphTypeNum(filetype);
-      if section = 'top' then
-        MakeDateline(section, aTitle, filetype, chartDatelineTop, graphtype, bcnt, pcnt, gcnt, vcnt, acnt)
-      else
-        MakeDateline(section, aTitle, filetype, chartDatelineBottom, graphtype, bcnt, pcnt, gcnt, vcnt, acnt);
-    end;
-    if section = 'top' then
-    begin
-      scrlTop.Align := alTop;
-      scrlTop.Height := 1; //pnlScrollTopBase.Height div 4;
-      pnlDatelineTop.Align := alClient;
-      pnlDatelineTop.Visible := true;
-    end
-    else
-    begin
-      scrlBottom.Align := alTop;
-      scrlBottom.Height := 1; //pnlScrollBottomBase.Height div 4;
-      pnlDatelineBottom.Align := alClient;
-      pnlDatelineBottom.Visible := true;
-    end;
-  end
-  else if onlylines then
-  begin
-    lcnt := 0;
-    for j := 0 to aListView.Items.Count - 1 do
-    if aListView.Items[j].Selected then
-    begin
-      aGraphItem := TGraphItem(aListView.Items.Item[j].SubItems.Objects[3]);
-      filetype := Piece(aGraphItem.Values, '^', 1);
-      typeitem := Piece(aGraphItem.Values, '^', 2);
-      if (filetype = '63') and (lstData.Items.Count > 0) then    //***********
-      begin
-        checkdata := '';
-        for i := 0 to lstData.Items.Count - 1 do
-        begin
-          checkdata := lstData.Items[i];
-          if (Piece(checkdata, '^', 1) = '63') and (Piece(checkdata, '^', 2) = typeitem) then
-            break;
-        end;
-        specnum := Piece(checkdata, '^', 7);
-        specimen := Piece(checkdata, '^', 8);
-        RefUnits(typeitem, specnum, low, high, units);
-        units := LowerCase(units);
-        if units = '' then units := '  ';
-      end
-      else
-      begin
-        specimen := ''; low := ''; high := ''; units := '';
-      end;
-      aTitle := filetype + '^' + typeitem + '^' + aListView.Items[j].Caption + '^' +
-                specimen + '^' + low + '^' + high + '^' + units;
-      MakeLineSeries(newchart, aTitle, filetype, lcnt, ncnt, true)
-    end;
-    if section = 'top' then
-    begin
-      pnlDatelineTop.Align := alBottom;
-      pnlDatelineTop.Height := 5;
-      scrlTop.Align := alClient;
-      pnlDatelineTop.Visible := false;
-    end
-    else
-    begin
-      pnlDatelineBottom.Align := alBottom;
-      pnlDatelineBottom.Height := 5;
-      scrlBottom.Align := alClient;
-      pnlDatelineBottom.Visible := false;
-    end;
-    with newchart do
-    begin
-      if btnChangeSettings.Tag = 1 then
-        LeftAxis.Title.Caption := 'StdDev';
-      Visible := true;
-    end;
-  end
-  else if anylines then
-  begin
-    pcnt := 0; gcnt := 0; vcnt := 0; lcnt := 0; ncnt := 0; bcnt := 0; acnt := 0;
-    cnt := 0;
-    for j := 0 to aListView.Items.Count - 1 do
-    if aListView.Items[j].Selected then
-    begin
-      aGraphItem := TGraphItem(aListView.Items.Item[j].SubItems.Objects[3]);
-      filetype := Piece(aGraphItem.Values, '^', 1);
-      if filetype = '120.5' then
-      begin
-        cnt := BIG_NUMBER;
-        break;
-      end;
-      if filetype = '63' then
-        cnt := cnt + 1;
-      if cnt > 1 then
-        break;
-    end;
-    singlelabtest := cnt = 1;
-    for j := 0 to aListView.Items.Count - 1 do
-    if aListView.Items[j].Selected then
-    begin
-      aGraphItem := TGraphItem(aListView.Items.Item[j].SubItems.Objects[3]);
-      filetype := Piece(aGraphItem.Values, '^', 1);
-      typeitem := Piece(aGraphItem.Values, '^', 2);
-      if (filetype = '63') and (lstData.Items.Count > 0) then    //***********
-      begin
-        checkdata := '';
-        for i := 0 to lstData.Items.Count - 1 do
-        begin
-          checkdata := lstData.Items[i];
-          if (Piece(checkdata, '^', 1) = '63') and (Piece(checkdata, '^', 2) = typeitem) then
-            break;
-        end;
-        specnum := Piece(checkdata, '^', 7);
-        specimen := Piece(checkdata, '^', 8);
-        RefUnits(typeitem, specnum, low, high, units);
-        units := LowerCase(units);
-        if units = '' then units := '  ';
-      end
-      else
-      begin
-        specimen := ''; low := ''; high := ''; units := '';
-      end;
-      aTitle := filetype + '^' + typeitem + '^' + aListView.Items[j].Caption + '^' +
-                specimen + '^' + low + '^' + high + '^' + units;
-      graphtype := GraphTypeNum(filetype);
-      if graphtype = 1 then
-      begin
-        if btnChangeSettings.Tag = 1 then
-          newchart.LeftAxis.Title.Caption := 'StdDev'
-        else
-          newchart.LeftAxis.Title.Caption := units;
-        if singlelabtest then
-          splGraphs.Tag := 1
-        else
-          splGraphs.Tag := 0;
-        MakeLineSeries(newchart, aTitle, filetype, lcnt, ncnt, true);
-      end
-      else if section = 'top' then
-        MakeDateline(section, aTitle, filetype, chartDatelineTop, graphtype, bcnt, pcnt, gcnt, vcnt, acnt)
-      else
-        MakeDateline(section, aTitle, filetype, chartDatelineBottom, graphtype, bcnt, pcnt, gcnt, vcnt, acnt);
-    end;
-    if section = 'top' then
-    begin
-      scrlTop.Align := alTop;
-      pnlDatelineTop.Align := alBottom;
-      pnlDatelineTop.Height := pnlScrollTopBase.Height div 2;
-      scrlTop.Align := alClient;
-      pnlDatelineTop.Visible := true;
-    end
-    else
-    begin
-      scrlBottom.Align := alTop;
-      pnlDatelineBottom.Align := alBottom;
-      pnlDatelineBottom.Height := pnlScrollBottomBase.Height div 2;
-      scrlBottom.Align := alClient;
-      pnlDatelineBottom.Visible := true;
-    end;
-    with newchart do
-    begin
-      if btnChangeSettings.Tag = 1 then
-        LeftAxis.Title.Caption := 'StdDev';
-      Visible := true;
-    end;
-  end;
+  if nolines then MakeTogetherNoLines(aListView, section)
+  else if onlylines then MakeTogetherOnlyLines(aListView, section, newchart)
+  else if anylines then MakeTogetherAnyLines(aListView, section, newchart);
+  MakeOtherSeries(newchart);
+
+  singlepoint := (lcnt = 1) or (pcnt = 1) or (bcnt = 1) or (vcnt = 1);
+  GraphBoundry(singlepoint);
+  if FNonNumerics then
+    if section = 'top' then pnlItemsTop.Tag := 1
+    else pnlItemsBottom.Tag := 1;
+end;
+
+procedure TfrmGraphs.GraphBoundry(singlepoint: boolean);
+begin
   if (FGraphSetting.HighTime = FGraphSetting.LowTime)
-  or (lcnt = 1) or (pcnt = 1) or (bcnt = 1) or (acnt = 1) or (vcnt = 1) then
+  or singlepoint then
   begin
     FGraphSetting.HighTime := FGraphSetting.HighTime + 1;
